(PackageInfo named: 'acceptit-Tests') preamble: '"below, add code to be run before the loading of this package"
ACLibraryCompiler provisionLibrary: ''ACVerticalPrototypeLibrary''.
ACLibraryCompiler provisionLibrary: ''ACStepExecutionLibrary''.'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
SystemOrganization addCategory: #'acceptit-Tests-Calculator'!

ACUserStory subclass: #ACPlayfieldUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Calculator'!

!ACPlayfieldUserStory class methodsFor: 'initialize-release' stamp: 'mp 3/29/2011 15:37:20.796'!
initialize
	
	super initialize.
	self userStoryString: 'AC Playfield User Story
In order to test acceptit
As a developer
I want to implement a small calculator'. ! !

!ACPlayfieldUserStory class methodsFor: 'as yet unclassified' stamp: 'mp 3/29/2011 15:46:38.231'!
libraries

	^ {ACCalculatorLibrary}! !

!ACPlayfieldUserStory methodsFor: 'scenarios' stamp: 'mp 3/30/2011 09:42:43.851'!
add result

Given I have added
When I add 4 to result
Then I expect 11! !

!ACPlayfieldUserStory methodsFor: 'scenarios' stamp: 'mp 3/30/2011 09:42:52.197'!
addition

Given A is 3
And B is 4
When I add A and B
Then I expect 7! !

!ACPlayfieldUserStory methodsFor: 'scenarios' stamp: 'mp 3/30/2011 09:42:58.327'!
subtraction

Given A is 3
And B is 4
When I subtract A and B
Then I expect -1! !

ACUserStory subclass: #ACStepExecutionUserStory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACStepExecutionUserStory class methodsFor: 'initialize-release' stamp: 'mp 3/29/2011 15:27:49.439'!
initialize
	
	super initialize.
	self userStoryString: 'AC Step Execution User Story 
In order to test step execution
As a tester
I want to have some scenarios'. ! !

!ACStepExecutionUserStory class methodsFor: 'initialize-release' stamp: 'db 10/10/2010 17:40'!
libraries

	^ {ACStepExecutionLibrary}
! !

!ACStepExecutionUserStory methodsFor: 'as yet unclassified' stamp: 'db 10/10/2010 17:39'!
error scenario

Given passing step
When error step
Then passing step! !

!ACStepExecutionUserStory methodsFor: 'as yet unclassified' stamp: 'db 10/10/2010 17:39'!
failing scenario

Given passing step
When passing step
Then failing step! !

!ACStepExecutionUserStory methodsFor: 'as yet unclassified' stamp: 'topa 3/11/2011 14:19'!
passing scenario

Given passing step
And passing step
When passing step
Then passing step! !

WAComponent subclass: #ACTestRootComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 12:49'!
canBeRoot

^true! !

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 13:01'!
registerApplication

^WAAdmin 
		register: self
		asApplicationAt: 'ACTest'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'topa 6/23/2010 15:45'!
renderContentOn: html
 "I render everything by calling html"

	html paragraph: 'Hello World'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'db 6/29/2010 15:27'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Hello World'.! !

Object subclass: #ACCalculator
	instanceVariableNames: 'first second result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Calculator'!

!ACCalculator methodsFor: 'computation' stamp: 'mp 3/29/2011 17:04:51.805'!
add
	self result: self first + self second! !

!ACCalculator methodsFor: 'computation' stamp: 'mp 3/29/2011 17:19:59.602'!
addToResult: aNumber

	self result: self result + aNumber.! !

!ACCalculator methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:55:35.31'!
first
	"Answer the value of first"

	^ first! !

!ACCalculator methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:55:35.328'!
first: anObject
	"Set the value of first"

	first := anObject! !

!ACCalculator methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:55:35.378'!
result
	"Answer the value of result"

	^ result! !

!ACCalculator methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:55:35.395'!
result: anObject
	"Set the value of result"

	result := anObject! !

!ACCalculator methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:55:35.345'!
second
	"Answer the value of second"

	^ second! !

!ACCalculator methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:55:35.361'!
second: anObject
	"Set the value of second"

	second := anObject! !

!ACCalculator methodsFor: 'computation' stamp: 'mp 3/29/2011 17:17:22.997'!
subtract
	self result: self first - self second! !

Object subclass: #ACStepExecutionLibrary
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACStepExecutionLibrary class methodsFor: 'as yet unclassified' stamp: 'db 10/9/2010 20:55'!
compilerClass

	^ ACLibraryCompiler! !

!ACStepExecutionLibrary class methodsFor: 'as yet unclassified' stamp: 'db 10/9/2010 21:09'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACStepExecutionLibrary class methodsFor: 'as yet unclassified' stamp: 'db 10/9/2010 21:09'!
parserClass

	^ ACSDParser! !

!ACStepExecutionLibrary class methodsFor: 'as yet unclassified' stamp: 'db 10/9/2010 21:09'!
shoutParserClass

	^ACSHParserForLibrary! !

!ACStepExecutionLibrary methodsFor: 'nil' stamp: 'db 10/9/2010 21:15'!
(given) passing step

! !

!ACStepExecutionLibrary methodsFor: 'accessing' stamp: 'db 10/10/2010 17:45'!
scenario
	"Answer the value of scenario"

	^ scenario! !

!ACStepExecutionLibrary methodsFor: 'accessing' stamp: 'db 10/10/2010 17:45'!
scenario: anObject
	"Set the value of scenario"

	scenario := anObject! !

!ACStepExecutionLibrary methodsFor: 'nil' stamp: 'topa 11/2/2010 18:51'!
(then) failing step

	self scenario fail

! !

!ACStepExecutionLibrary methodsFor: 'nil' stamp: 'topa 11/2/2010 18:51'!
(then) passing step

	self scenario assert: true

! !

!ACStepExecutionLibrary methodsFor: 'nil' stamp: 'db 10/9/2010 22:35'!
(when) error step

	^ Error signal

! !

!ACStepExecutionLibrary methodsFor: 'nil' stamp: 'db 10/9/2010 21:16'!
(when) passing step

! !

Object subclass: #ACVerticalPrototypeLibrary
	instanceVariableNames: 'scenario'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACVerticalPrototypeLibrary class methodsFor: 'as yet unclassified' stamp: 'mp 3/29/2011 12:05:38.158'!
compilerClass

	^ACLibraryCompiler
! !

!ACVerticalPrototypeLibrary class methodsFor: 'as yet unclassified' stamp: 'db 7/9/2010 12:45'!
newForScenario: aUserStoryObjectBeeingAScenario

	^ self basicNew
		scenario: aUserStoryObjectBeeingAScenario;
		initialize! !

!ACVerticalPrototypeLibrary class methodsFor: 'as yet unclassified' stamp: 'mp 3/29/2011 12:05:38.14'!
parserClass

^ ACSDParser
! !

!ACVerticalPrototypeLibrary class methodsFor: 'as yet unclassified' stamp: 'mp 3/29/2011 12:05:38.122'!
shoutParserClass

	^ ACSHParserForLibrary
! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:11'!
givenHasAWebSite

	"see setUp. has to be done there, because albatross expects a 
	running service during setup."! !

!ACVerticalPrototypeLibrary methodsFor: 'accessing' stamp: 'db 7/9/2010 12:47'!
scenario

	^scenario! !

!ACVerticalPrototypeLibrary methodsFor: 'accessing' stamp: 'db 7/9/2010 12:47'!
scenario: anObject

	scenario := anObject! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:11'!
setUp

	WASwazooAdaptor startOn: (self scenario configuration at: #albatrossPort). 
	ACTestRootComponent registerApplication.
	(Delay forMilliseconds: 500) wait.
! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 15:12'!
tearDown

	 |adaptor |
		
	WADispatcher default unregister: 'ACTest'.
	adaptor := WAAdmin serverAdaptors detect: [:a | a port = 9999] ifNone: [nil].
	adaptor ifNotNil: [:a|
		a isRunning ifTrue: [ a stop ].
		(Delay forMilliseconds: 250) wait.
		(a isRunning or: [a isStopping]) ifTrue: [a kill]	].! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 09:34'!
thenSeeHelloWorld

	
	^ self scenario browser textExists: 'Hello World'! !

!ACVerticalPrototypeLibrary methodsFor: 'as yet unclassified' stamp: 'topa 7/15/2010 09:40'!
whenGoToTheWebSite

	" this is done by the Albatross lib. No need to implement "! !

TestCase subclass: #ACArgumentParsingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:00'!
testArgumentParsing

	|body selectorString variableAssociations|

	body:= 'see potatoe on the 2. screen fert'.
	selectorString:= 'see :thing on the :number screen :name'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.

	self should: [variableAssociations  = {':thing'->'potatoe' . ':number'->'2.'. ':name'->'fert'} asOrderedCollection]. ! !

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:00'!
testArgumentParsingWithASingleArgument

	|body selectorString variableAssociations|

	body:= 'see Hello World'.
	selectorString:= 'see :aString'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.

	self should: [variableAssociations  = {':aString' -> 'Hello World'} asOrderedCollection].! !

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:01'!
testArgumentParsingWithSpecialCharacters

	|body selectorString variableAssociations|

	body:= 'see potat:oe on the 2 . screen frt'.
	selectorString:= 'see :thing on the :number screen :name'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.
	
	self should: [variableAssociations  = {':thing'->'potat:oe' . ':number'->'2 .'. ':name'->'frt'} asOrderedCollection]. ! !

!ACArgumentParsingTest methodsFor: 'as yet unclassified' stamp: 'topa 8/31/2010 03:01'!
testArgumentParsingWithoutArguments

	|body selectorString variableAssociations|

	body:= 'nothing happens'.
	selectorString:= 'nothing happens'.

	variableAssociations := ACTranslator bindParametersInSelector: selectorString toValuesIn: body.

	self should: [variableAssociations  = (OrderedCollection new)]. ! !

TestCase subclass: #ACCompilerScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:47:47.591'!
testScenarioCompilation

	|scenario acMethod stMethod scenarioDecompiled |
	scenario := 'hello
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
	
	scenarioDecompiled := 'hello
		<scenario>
		self given: ''I have a web site''.
		self when: ''I go to the web site''.
		self then: ''I see "Hello World"''.'.
	
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: scenarioDecompiled in: self class classified: nil notifying: nil ifFail: [].
	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'topa 9/24/2010 14:53'!
testScenarioHasCorrectName

	|scenario acMethod |
	scenario := 'Here should be the name of the method
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
		
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	
	self 
		should: [acMethod selector =  'Here should be the name of the method'].
		 ! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:07'!
directClassWithVariablesSet

	| theKlass |
	theKlass := (ACUserStory subclass: self klassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: ACUserStory category).
	^ theKlass purpose: 'impress the ladies'; role: 'Casanova'; means: 'Prosecco'.! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName

	^ klassName! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName: anObject

	klassName := anObject! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 9/22/2010 11:30'!
parseTree

	^ ACTranslator match: (ACUSParser matchStream: 
'A Name For Testing
In order to impress the ladies
As a Casanova
I want Prosecco
' readStream with: #userStory withArgs: #() withPlaybackDebugging: false) with: #scenario! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:08'!
removeTestClass

	self klassName ifNotNilDo: [:name | 
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 13:57'!
setUp

	self klassName: #ANameForTesting.! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 14:02'!
tearDown

	self removeTestClass.! !

!ACCompilerUserStoryTest methodsFor: 'testing' stamp: 'topa 4/27/2011 08:37'!
testUserStoryCompilation

	| direct indirect generated |
	direct := self directClassWithVariablesSet definition.
	self removeTestClass.
	indirect := (ACUserStory named: self klassName
		purpose: 'impress the ladies' 
		role: 'Casanova'
		means: 'Prosecco'
		category: 'Generated') definition.
	self removeTestClass.
	generated := (Compiler evaluate: self parseTree notifying: nil logged: false) definition.
	self removeTestClass.
	
	self 
		should: [direct = indirect];
		should: [indirect = generated].! !

TestCase subclass: #ACDeltaFunctionTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:28'!
klassName

	^klassName! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:28'!
klassName: anObject

	klassName := anObject! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:29'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:19'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/8/2010 15:20'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'topa 7/8/2010 15:07'!
testWithHaveAsString
	"comment stating purpose of message"
	
	|testString expectedString |
	testString := 'have a WebSite'.
	expectedString := 'has a WebSite'.
	self assert:  (testString withLeadingAuxiliaryNormalized) = expectedString.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'topa 7/8/2010 15:09'!
testWithIAndHaveAsSelector
	"comment stating purpose of message"
	
	|testString expectedString |
	testString := 'I have a WebSite'.
	expectedString := 'has a WebSite'.
	
	self assert:  (testString withoutLeadingSubject withLeadingAuxiliaryNormalized) = expectedString.! !

!ACDeltaFunctionTest methodsFor: 'as yet unclassified' stamp: 'db 7/21/2010 01:22'!
testWithIAndShouldAsSelector
	
	| userStory testString expectedSymbol |
	userStory := ('AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory) new.

	testString := 'I should have four cars in stock'.
	expectedSymbol := #givenShouldHaveFourCarsInStock.
	
	self assert: (userStory class selectorForString: testString prefixed: #given) = expectedSymbol.
	! !

TestCase subclass: #ACParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

ACParserTest subclass: #ACParserScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserScenarioTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:32'!
parserClassToTest

	^ ACUSParser! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:09'!
testScenarioAnd

	|and|
	and:= 'And I have a web site'.
	self should: [self match: and with: #and].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:10'!
testScenarioGiven

	|given|
	given:= 'Given I have a web site'.

	self should: [self match: given with: #given].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:11'!
testScenarioGivenAnd

	|given|
	given:= 
'Given I have a web site
And I am not logged in'.

	self should: [self match: given with: #applyLines withArgs: #(given)].	! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:35:50.72'!
testScenarioInvalidNewlinesMatch

|scenarioInvalidNewlines|
	
	scenarioInvalidNewlines := 'Given I have a web site
	
		When I go to the web site
		
		Then I see "Hello World"'.
	self shouldnt: [self match:  scenarioInvalidNewlines with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:03.478'!
testScenarioInvalidOrderMatch

|scenarioInvalidOrder|

	scenarioInvalidOrder:= 'When I go to the web site
		Given I have a web site
		Then I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidOrder with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:51.013'!
testScenarioInvalidSyntaxMatch
|scenarioInvalidSyntax|

	scenarioInvalidSyntax:= 'Gvien I have a web site
		Wehn I go to the web site
		Tehn I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidSyntax with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:13:37.893'!
testScenarioInvalidTrailersMatch

|scenarioInvalidTrailers|
scenarioInvalidTrailers:= 'Given I have a web site
	When I go to the web site
	Then I see "Hello World"
	Yes, This would be awesome.'.
	
	self shouldnt: [self match: scenarioInvalidTrailers with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 6/30/2010 13:10'!
testScenarioMatch

	|scenario|
	scenario:= 'Hello World
	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'topa 6/30/2010 13:11'!
testScenarioMatchAnd
	
	|scenario|
	scenario:= 'Hello World
	Given I have a web site
	And I am not logged in
	When I go to the web site
	And I click "Login"
	Then I see "Hello"
	And I see "World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/15/2010 16:30:43.661'!
testScenarioMissingName
|scenario|

	scenario:= '	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self shouldnt: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:13'!
testScenarioThen
	
	|then|
	then := 'Then I see "Hello World"'.
	
	self should: [self match: then with: #then].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:14'!
testScenarioThenAnd
	
	|then|
	then := 
'Then I see "Hello"
And I see "World"'.
	
	self should: [self match: then with: #applyLines withArgs: #(then)].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:14'!
testScenarioWhen

	|when|
	when:= 'When I go to the web site'.
	self should: [self match: when with: #when].! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'topa 6/30/2010 14:15'!
testScenarioWhenAnd

	|when|
	when:= 
'When I go to the web site
And I click "Login"'.

	self should: [self match: when with: #applyLines withArgs: #(when)].! !

ACParserTest subclass: #ACParserStepdefTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserStepdefTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:32'!
parserClassToTest

	^ ACSDParser! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 8/5/2010 11:05'!
testStepdefMatch

	|stepdef|
	stepdef:= 
	'(given) is a User
	^ self.'.
	
	self should: [self match: stepdef with: #stepDefinition].
! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 8/31/2010 03:22'!
testStepdefMatchArg

	|stepdef|
	stepdef:= 
	'(given) has :number opportunities
	^ self.'.
	
	self should: [self match: stepdef with: #stepDefinition].
! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 9/22/2010 11:56'!
testStepdefMatchArgPt

	|stepdef pt|
	stepdef:= 
	'(given) has :number opportunities
	^ self.'.
	pt := #(#given 'has :number opportunities' '	^ self.').
	
	self should: [(ACSDParser matchAll: stepdef with: #stepDefinition) = pt].
! !

!ACParserStepdefTest methodsFor: 'tests' stamp: 'topa 9/22/2010 11:56'!
testStepdefMatchPt

	|stepdef pt|
	stepdef:= 
	'(given) is a User
	^ self.'.
	pt := #(#given 'is a User' '	^ self.').
	
	self should: [(ACSDParser matchAll: stepdef with: #stepDefinition) = pt].
! !

!ACParserTest class methodsFor: 'as yet unclassified' stamp: 'topa 5/27/2010 14:50'!
isAbstract

	^ self == ACParserTest! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 6/30/2010 14:12'!
match: aString with: aRule

	^ self match: aString with: aRule withArgs: #()
! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:31'!
match: aString with: aRule withArgs: args

	[self parserClassToTest matchAll: aString with: aRule withArgs: args]
		on: OM2Fail
		do: [^ false].
	^ true! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:31'!
parserClassToTest

	self subclassResponsibility! !

ACParserTest subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'helpers' stamp: 'topa 9/22/2010 11:31'!
parserClassToTest

	^ ACUSParser! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:36:39.815'!
testUserStoryInvalidNewlinesMatch

	|userStoryInvalidNewlines|
	userStoryInvalidNewlines :='A Title
		In order to achieve something
		
		As a role
		
		I want to do something.'.
	self shouldnt: [self match: userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:18:37.474'!
testUserStoryInvalidOrderMatch

	|userStoryInvalidOrder|
	userStoryInvalidOrder := 'A Title
		As a role
		I want to do something
		In order to achieve something.'.
	self shouldnt: [self match: userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:19:35.46'!
testUserStoryInvalidSyntaxMatch

	|userStoryInvalidSyntax|
	userStoryInvalidSyntax := 'A Title
		In roder to achieve something
		Asa role
		I wnat ot do something.'.
	self shouldnt: [self match: userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:20:19.864'!
testUserStoryInvalidTrailersMatch

	|userStoryInvalidTrailers|
	userStoryInvalidTrailers := 'A Title
		In order to achieve something
		As a role
		I want to do something.
	
		This is cool
		'.
	self shouldnt: [self match: userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:21:18.908'!
testUserStoryMatch

	|userStory|
	userStory := 'A Title
		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match: userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:22:37.873'!
testUserStoryMeansMatch

	|means|
	means:= 'I want to do something.'.
	self should: [self match: means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:23:49.879'!
testUserStoryMeansOptionalToMatch

	|meansOptionalTo|
	meansOptionalTo := 'I want a cake.'.
	self should: [  self match: meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:24:39.316'!
testUserStoryMeansOptionalToWithAnMatch

|meansOptionalToWithAn|
	meansOptionalToWithAn :='I want an embedded sleeping hour.'.
	self should: [  self match: meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:26:24.557'!
testUserStoryMissingArgsMatch

	|userStoryMissingArgs|
	userStoryMissingArgs := 'A Title
		In order to
		As a
		I want'.
	self shouldnt: [self match: userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:27:38.785'!
testUserStoryNewlineAfterTitleMatch
	
	|userStoryNewlineAfterTitle|
	userStoryNewlineAfterTitle := 'A Title

		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match:  userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:28:44.094'!
testUserStoryPurposeMatch

	|purpose|
	purpose := 'In order to achieve something.'.
	self should: [  self match: purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:29:30.091'!
testUserStoryRoleMatch

	|role|
	role :=  'As a role'.
	self should: [ self match: role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:09.156'!
testUserStoryRoleWithAnMatch

	|roleWithAn|
	roleWithAn := 'As an emancipated role'.
	self should: [ self match: roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:47.067'!
testUserStoryRoleWithPluralMatch
	
	|roleWithPlural|
	roleWithPlural:='As roles'.
	self shouldnt: [ self match: roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:31:33.05'!
testUserStorySpacingMatch
	
	|userStorySpacing|
	userStorySpacing := 
	'A Title
	    In order to achieve something
		As a role
	 	 I want to do something.'.
	self should: [self match: userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

TestCase subclass: #ACStepExecutionTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACStepExecutionTest methodsFor: 'testing' stamp: 'db 10/25/2010 13:35'!
testErrorStep

	| result expectedStepStatus |
	result := (ACStepExecutionUserStory run: 'error scenario').
	expectedStepStatus :=  ({'ACStepExecutionUserStory>>#error scenario' -> #('passed' 'error' 'skipped')} as: Dictionary).
	
	self should: [result hasErrors].
	self shouldnt: [result hasFailures].
	self should: [ result stepStatus = expectedStepStatus ].! !

!ACStepExecutionTest methodsFor: 'testing' stamp: 'db 10/25/2010 13:36'!
testFailingStep

	| result expectedStepStatus |
	result := (ACStepExecutionUserStory run: 'failing scenario').
	expectedStepStatus :=  ({'ACStepExecutionUserStory>>#failing scenario' -> #('passed' 'passed' 'failed')} as: Dictionary).
	
	self should: [result hasFailures].
	self shouldnt: [result hasErrors].
	self should: [result stepStatus = expectedStepStatus].
	
! !

!ACStepExecutionTest methodsFor: 'testing' stamp: 'db 10/25/2010 13:37'!
testPassingStep

	| result expectedStepStatus |
	result := (ACStepExecutionUserStory run: 'passing scenario').
	expectedStepStatus :=  ({'ACStepExecutionUserStory>>#passing scenario' -> #('passed' 'passed' 'passed' 'passed')} as: Dictionary).
	
	self should: [result hasPassed].
	self shouldnt: [result hasFailures].
	self shouldnt: [result hasErrors].
	self should: [result stepStatus = expectedStepStatus].
	
! !

TestCase subclass: #ACTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testGivenMultiTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site' 'I am not logged in').
	sourceCode:= '	self given: ''I have a web site''.', String cr, '	self given: ''I am not logged in''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testGivenTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site').
	sourceCode:= '	self given: ''I have a web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:39'!
testMeansTranslation

	| pt |
	pt:= #(means 'do something.').
	self should: (ACTranslator match: pt with: #messagePart) = ('	means: ''do something.''', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:40'!
testPurposeTranslation

	| pt |
	pt:= #(purpose 'achieve something').
	self should: (ACTranslator match: pt with: #messagePart) = ('	purpose: ''achieve something''', String cr).
	! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:41'!
testRoleTranslation

	| pt |
	pt:= #(role 'role').
	self should: (ACTranslator match: pt with: #messagePart) = ('	role: ''role''', String cr).! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 9/22/2010 11:24'!
testScenarioMultiTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site' 'I am not logged in')
			#(#when 'I go to the web site' 'I click "Login"')
			#(#then 'I see "Hello"' 'I see "World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self given: ''I am not logged in''.
	self when: ''I go to the web site''.
	self when: ''I click "Login"''.
	self then: ''I see "Hello"''.
	self then: ''I see "World"''.', String cr.
	self should: (ACTranslator match: pt with: #scenario) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 9/22/2010 11:24'!
testScenarioTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site')
			#(#when 'I go to the web site')
			#(#then 'I see "Hello World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #scenario) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-stepdef' stamp: 'topa 9/24/2010 14:53'!
testStepDefMatch

	|pt source|
	pt := #(#given 'is a User' '	^ self.').
	source := 
	'givenIsAUserArgs: privateArgsCollection
	<stepTag: #given>
	<stepMatch: ''is a User''>
	<step: ''is a User''>
[
	^ self.
] valueWithPossibleArgs: (privateArgsCollection asArray).
'.
	
	self should: [ (ACTranslator match: pt with: #stepDefinition) = source].! !

!ACTranslatorTest methodsFor: 'tests-stepdef' stamp: 'topa 9/24/2010 14:53'!
testStepDefMatchArg

	|pt source|
	pt := #(#given 'has :number opportunities' '	^ self.').
	source := 
	'givenHasnumberOpportunitiesArgs: privateArgsCollection
	<stepTag: #given>
	<stepMatch: ''has * opportunities''>
	<step: ''has :number opportunities''>
[:number |
	^ self.
] valueWithPossibleArgs: (privateArgsCollection asArray).
'.
	
	self should: [ (ACTranslator match: pt with: #stepDefinition) = source].! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testThenMultiTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello"' 'I see "World"').
	sourceCode:= '	self then: ''I see "Hello"''.', String cr,'	self then: ''I see "World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:45'!
testThenTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello World"').
	sourceCode:= '	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:42'!
testTitleTranslation

	| pt |
	pt:= #(title 'A Title').
	self should: (ACTranslator match: pt with: #title) = ('ACUserStory named: #ATitle', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 9/22/2010 11:24'!
testUserStoryTranslation

	| pt source |
	pt:= #(userStory
		#(title 'A Title') 
		#(purpose 'achieve something') 
		#(role 'role') 
		#(means 'do something.')).
	source := 'ACUserStory named: #ATitle
	purpose: ''achieve something''
	role: ''role''
	means: ''do something.''
'.
	self should: (ACTranslator match: pt with: #scenario) = source.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 6/30/2010 14:29'!
testWhenMultiTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site' 'I log in').
	sourceCode:= '	self when: ''I go to the web site''.', String cr,'	self when: ''I log in''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testWhenTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site').
	sourceCode:= '	self when: ''I go to the web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

TestCase subclass: #ACVerticalPrototypeTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName

	^klassName! !

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName: anObject

	klassName := anObject! !

!ACVerticalPrototypeTest methodsFor: 'helper' stamp: 'fg 6/10/2010 19:57:56.355'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACVerticalPrototypeTest methodsFor: 'testing' stamp: 'topa 7/15/2010 15:11'!
testVerticalPrototype
	<timeout: 10>
	| userStory scenario numOfMethods storedMethod |

	userStory := 'AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory.
	self 
		should: [userStory inheritsFrom: TestCase];
		should: [userStory name = self klassName].
	
	numOfMethods := userStory methodDict size.
	scenario := userStory compile: 
'Hello World Test
Given I have a web site
When I go to the web site
Then I see "Hello World"'
						 classified: nil.
	self 
		should: [userStory methodDict size = (numOfMethods +1)];
		should: [userStory methodDict includesKey: scenario].
	
	" Configuration "
	userStory class compile: 'libraries ^ {ACVerticalPrototypeLibrary . ACAlbatrossLibrary}'.
	userStory class compile: 'buildConfiguration: aDictionary

	aDictionary 
		at: #albatrossSubjectApplication
			put: (WADispatcher default entryPointAt: ''ACTest'');
		at: #albatrossPort
			put: 9999.'.
	
	"ACTestRootComponent is hard coded in ACVerticalPrototypeTest"
	"generate empty renderContentOn:"
	storedMethod := ACTestRootComponent methodDict at: #renderContentOn: ifAbsent: [self error].
	[ACTestRootComponent methodDict removeKey: #renderContentOn:.
	self should: [(userStory run: scenario) hasFailures].
	] ensure: [ACTestRootComponent methodDict at: #renderContentOn: put: storedMethod].
	
	self should: [(userStory run: scenario)  hasPassed].! !

ACLibrary subclass: #ACCalculatorLibrary
	instanceVariableNames: 'calculator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Calculator'!

!ACCalculatorLibrary methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:57:42.624'!
calculator
	"Answer the value of calculator"

	^ calculator! !

!ACCalculatorLibrary methodsFor: 'accessing' stamp: 'mp 3/29/2011 16:57:42.642'!
calculator: anObject
	"Set the value of calculator"

	calculator := anObject! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/29/2011 17:02:44.029'!
(given) A is :aNumber

	self calculator first: aNumber asNumber.! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/30/2011 09:48:04.331'!
(given) abc

! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/29/2011 17:02:39.885'!
(given) B is :aNumber

	self calculator second: aNumber asNumber.! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/30/2011 10:00:41.275'!
(given) has added

	self scenario givenScenario: #addition.! !

!ACCalculatorLibrary methodsFor: 'testing' stamp: 'mp 3/29/2011 16:58:00.534'!
setUp
	self calculator: ACCalculator new.! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/29/2011 17:02:21.69'!
(then) expect :result

	self assert: self calculator result = result asNumber.! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/29/2011 17:03:05.018'!
(when) add A and B

	self calculator add.! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/29/2011 17:21:39.13'!
(when) add :aNumber to result

	self calculator addToResult: aNumber asNumber.! !

!ACCalculatorLibrary methodsFor: 'step definitions' stamp: 'mp 3/29/2011 17:17:50.658'!
(when) subtract A and B

	self calculator subtract.! !
ACPlayfieldUserStory initialize!
ACStepExecutionUserStory initialize!
